/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.wahl.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="WAHL_PARAMETER.WahlAndSchluessel",
     query="SELECT obj FROM WahlParameter obj WHERE obj.wahl = ?1 AND obj.schluessel = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHL_PARAMETER.Wahl",
     query="SELECT obj FROM WahlParameter obj WHERE obj.wahl = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHL_PARAMETER.WahlterminNotWahlAndSchluessel",
     query="SELECT obj FROM WahlParameter obj WHERE obj.wahltermin = ?1 AND obj.schluessel = ?2 AND obj.wahl IS NULL",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHL_PARAMETER.WahlterminNotWahl",
     query="SELECT obj FROM WahlParameter obj WHERE obj.wahltermin = ?1 AND obj.wahl IS NULL",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "WAHL_PARAMETER")
// @javax.persistence.IdClass(WahlParameterPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class WahlParameter
extends AbstractWahlParameter
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public WahlParameter() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public WahlParameter(WahlParameter original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "wahl_parameter_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "WahlParameter")
    @javax.persistence.TableGenerator(name = "WahlParameter", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "WahlParameter", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient WahlParameterPK pkCache;

  @Override
  public WahlParameterPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new WahlParameterPK(getId());
    }

    return pkCache;
  }

  public static <E extends WahlParameter> java.util.Map<WahlParameterPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<WahlParameterPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends WahlParameter> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedSchluessel = false;
          hasChangedWert = false;
  
      hasChangedWahltermin = false;
        hasChangedWahl = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
      @javax.persistence.Column(name = "SCHLUESSEL", nullable = WahlParameterConstants.SCHLUESSEL_NULLABLE, length=WahlParameterConstants.SCHLUESSEL_MAX_LENGTH)
        
  protected java.lang.String schluessel =  null;

  @javax.persistence.Transient
  protected boolean hasChangedSchluessel = false;

  public boolean hasChangedSchluessel(){
    return hasChangedSchluessel;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertSchluessel = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenSchluessel;
  
  /**
   * 
   *
   * getter for WAHL_PARAMETER.SCHLUESSEL
   */
    @Override   public  java.lang.String getSchluessel() {
        return schluessel;
      }

  /**
   * 
   *
   * setter for WAHL_PARAMETER.SCHLUESSEL
   *
   * @param schluessel
   */
  @Override   public void setSchluessel( java.lang.String schluessel) {

       resetTkCache();
                  
                          java.lang.String schluesselInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(schluessel, WahlParameterConstants.SCHLUESSEL_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.schluessel
      , schluesselInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedSchluessel |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("schluessel");
      }


             if (!isSeitLadenVeraendertSchluessel) {
          isSeitLadenVeraendertSchluessel = thisAttributChanged;
         if (isSeitLadenVeraendertSchluessel){
           wertNachLadenSchluessel=this.schluessel;
         }
       }
      

       this.schluessel = schluesselInternal;

         }

        
  @javax.persistence.Column(name = "WERT", nullable = WahlParameterConstants.WERT_NULLABLE, length=WahlParameterConstants.WERT_MAX_LENGTH)
        
  protected java.lang.String wert =  null;

  @javax.persistence.Transient
  protected boolean hasChangedWert = false;

  public boolean hasChangedWert(){
    return hasChangedWert;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertWert = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenWert;
  
  /**
   * 
   *
   * getter for WAHL_PARAMETER.WERT
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getWert() {
        return wert;
      }

  /**
   * 
   *
   * setter for WAHL_PARAMETER.WERT
   *
   * @param wert
   */
  @Override   public void setWert(@javax.annotation.Nullable  java.lang.String wert) {

       resetTkCache();
                  
                          java.lang.String wertInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(wert, WahlParameterConstants.WERT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wert
      , wertInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedWert |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("wert");
      }


             if (!isSeitLadenVeraendertWert) {
          isSeitLadenVeraendertWert = thisAttributChanged;
         if (isSeitLadenVeraendertWert){
           wertNachLadenWert=this.wert;
         }
       }
      

       this.wert = wertInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Wahltermin
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHLTERMIN_ID", referencedColumnName="WAHLTERMIN_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahltermin wahltermin;

  /**
   * 
   */
  @Override
  public void setWahltermin( de.ivu.elect.business.wahl.entity.Wahltermin wahltermin){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahltermin
    , wahltermin);

    attributeChanged |= thisAttributChanged;

    hasChangedWahltermin |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahltermin");
    }

    this.wahltermin = wahltermin;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.wahl.entity.Wahltermin getWahltermin(){
    return this.wahltermin;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahltermin = false;

  public boolean hasChangedWahltermin(){
    return hasChangedWahltermin;
  }

  /**
   * Beziehung (unidirektional) zu Wahl
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHL_ID", referencedColumnName="WAHL_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahl wahl;

  /**
   * 
   */
  @Override
  public void setWahl(@javax.annotation.Nullable  de.ivu.elect.business.wahl.entity.Wahl wahl){
    resetTkCache();
           de.ivu.elect.business.wahl.entity.Wahl alterWert = getWahl();
       preSetWahl(alterWert, wahl);
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahl
    , wahl);

    attributeChanged |= thisAttributChanged;

    hasChangedWahl |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahl");
    }

    this.wahl = wahl;
         postSetWahl(alterWert, wahl);
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.wahl.entity.Wahl getWahl(){
    return this.wahl;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahl = false;

  public boolean hasChangedWahl(){
    return hasChangedWahl;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("WahlParameter:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(WahlParameter other){
                             other.schluessel = this.schluessel;
                                other.wert = this.wert;
           
  other.setWahltermin(this.getWahltermin());
  other.setWahl(this.getWahl());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(WahlParameter.class)){
        copyEntityAttributesUsingSetter((WahlParameter) other.castTo(WahlParameter.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von WahlParameter: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(WahlParameter other){
               other.setSchluessel(this.schluessel);
                  other.setWert(this.wert);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(WahlParameter other){
                       if (hasChangedSchluessel) {
        other.setSchluessel(this.schluessel);
      }
                             if (hasChangedWert) {
        other.setWert(this.wert);
      }
             }





    @javax.persistence.Transient
    private transient WahlParameterTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public WahlParameterTK getWahlParameterTK(){
    if (tkCache==null) {
    tkCache = new WahlParameterTK(

getSchluessel()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getWahlParameterTK();
    }

  @Override
  public WahlParameterUK getUk(){
    return getWahlParameterUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return WahlParameter.class;
  }

public WahlParameterUK getWahlParameterUK(){

   return  new WahlParameterUK(



  );
}

  @javax.persistence.Transient
  private transient WahlParameterProperties properties;

  public WahlParameterProperties getProperties(){
    if (properties == null) {
      properties = new WahlParameterProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public WahlParameterProperties getWahlParameterProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return WahlParameterConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(WahlParameterConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlParameterConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL);

        schluessel =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WahlParameterConstants.MESSAGE_KEY_WERT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlParameterConstants.MESSAGE_KEY_WERT_EINZAHL);

        wert =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertSchluessel) {
      result.put(WahlParameterConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenSchluessel , schluessel));
    }
                            if (isSeitLadenVeraendertWert) {
      result.put(WahlParameterConstants.MESSAGE_KEY_WERT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenWert , wert));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertSchluessel = false;
      wertNachLadenSchluessel = null;
                          isSeitLadenVeraendertWert = false;
      wertNachLadenWert = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "WAHL_PARAMETER";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "WahlParameter";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(schluessel, this, WahlParameterConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(WahlParameterConstants.SCHLUESSEL_MAX_LENGTH , 1 ,  schluessel, this, WahlParameterConstants.MESSAGE_KEY_SCHLUESSEL_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(WahlParameterConstants.WERT_MAX_LENGTH ,  wert, this, WahlParameterConstants.MESSAGE_KEY_WERT_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
